import bpy

bl_info = {"name": "Mesh Operations", "category": "Mesh", "author": "Ali Soltanian Fard Jahromi", "version": (2,0), "blender": (2,83,0)}

def main(context):
    
    # deletes selected object
    bpy.ops.object.editmode_toggle()
    bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)
    
def main2(context):
    
    # deletes selected object and adds new UV Sphere and adds 2 levels of subdivision.
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)  
    bpy.ops.mesh.primitive_uv_sphere_add(enter_editmode=False, align='WORLD', location=(0, 0, 0))
    bpy.ops.object.subdivision_set(level=2, relative=False)

def main3(context):
    
    # deletes selected object and adds new grid object.
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)  
    bpy.ops.mesh.primitive_grid_add(size=5, enter_editmode=False, align='WORLD', location=(0, 0, 0))

def main4(context):
    # deletes selected object and adds new icosphere object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)
    bpy.ops.mesh.primitive_ico_sphere_add(radius=1, enter_editmode=False, align='WORLD', location=(0, 0, 0))

def main5(context):
    #deletes selected object and adds new cube object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)
    bpy.ops.mesh.primitive_cube_add(enter_editmode=False, align='WORLD', location=(0, 0, 0))
    
def main6(context):
    #deletes selected object and adds new plane object with particle system
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)
    bpy.ops.mesh.primitive_plane_add(size=5, enter_editmode=False, align='WORLD', location=(0, 0, 0))
    bpy.context.space_data.context = 'PARTICLES'
    bpy.ops.object.modifier_add(type='PARTICLE_SYSTEM')



def main7(context):
    #adds wireframe modifier to selected object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.modifier_add(type='BEVEL')




def main8(context):
    #adds wireframe modifier to selected object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.modifier_remove(modifier="Bevel")
        
def main9(context):
    #deletes selected object and adds new cube object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.delete(use_global=False, confirm=False)
    bpy.ops.mesh.primitive_cone_add(radius1=1, radius2=0, depth=2, enter_editmode=False, align='WORLD', location=(0, 0, 0))

def main10(context):
    #deletes selected object and adds new cube object
    if context.active_object.mode == 'EDIT':
        bpy.ops.object.editmode_toggle()
    bpy.ops.object.modifier_add(type='DECIMATE')
    bpy.context.object.modifiers["Decimate"].decimate_type = 'UNSUBDIV'
    bpy.context.object.modifiers["Decimate"].iterations = 9


    
    
class Delete(bpy.types.Operator):
    
    # Simple operator which deletes mesh.
    
    """removes selected objects"""
    bl_idname = "object.simple_operator"
    bl_label = "Delete Mesh"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main(context)
        return {'FINISHED'}


class RepWithSphere(bpy.types.Operator):
    
    # Operator for deleting selected mesh and adding a new UV sphere.
    
    """replaces selected object with sphere"""
    bl_idname = "object.simple11"
    bl_label = "Replace Mesh With Sphere"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main2(context)
        return {'FINISHED'}


class RepWithGrid(bpy.types.Operator):
    
    # Operator which deletes selected object and replaces it with grid object.
    
    """replaces selected object with grid"""
    bl_idname = "object.simple111"
    bl_label = "Replace Mesh With Grid"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main3(context)
        return {'FINISHED'}

class RepWithIcosphere(bpy.types.Operator):
    
    # Operator which deletes selected object and replaces it with icosphere object.
    
    """replaces selected object with icosphere"""
    bl_idname = "object.simple22"
    bl_label = "Replace Mesh With Icosphere"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main4(context)
        return {'FINISHED'}

class RepWithCube(bpy.types.Operator):
    
    # Operator which deletes selected object and replaces it with cube object.
    
    """replaces selected object with cube"""
    bl_idname = "object.simple33"
    bl_label = "Replace Mesh With Cube"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main5(context)
        return {'FINISHED'}
class AddPlnWithPtcleSstm(bpy.types.Operator):
    
    # Operator which deletes selected object and replaces it with plane object with particle system.
    
    """adds plane with particle system"""
    bl_idname = "object.simple44"
    bl_label = "Add Plane with Particle System"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main6(context)
        return {'FINISHED'}    
class AddBevelModifier(bpy.types.Operator):
    
    # Operator which adds wireframe modifier to selected object.
    
    """adds bevel modifier to selected object"""
    bl_idname = "object.simple55"
    bl_label = "Add Bevel Modfier"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main7(context)
        return {'FINISHED'}  
class RemoveBevelModifier(bpy.types.Operator):
    
    # Operator which adds wireframe modifier to selected object.
    
    """removes bevel modifier"""
    bl_idname = "object.simple66"
    bl_label = "Remove Bevel Modifier"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main8(context)
        return {'FINISHED'}           
class RepWithCone(bpy.types.Operator):
    
    # Operator which adds wireframe modifier to selected object.
    
    """replaces selected object with cone"""
    bl_idname = "object.simple77"
    bl_label = "Replace Mesh With Cone"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main9(context)
        return {'FINISHED'}    
class Decimate(bpy.types.Operator):
    
    # Operator which adds wireframe modifier to selected object.
    
    """lowers object's poly count"""
    bl_idname = "object.simple88"
    bl_label = "Unsubdivide Mesh"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main10(context)
        return {'FINISHED'}        
       
class MeshOperationsPanel(bpy.types.Panel):
    
    # Creates panel in object tab in properties tab.
    
    bl_label = "Mesh Operations"
    bl_idname = "Mesh Operations"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "object"

    def draw(self, context):
        layout = self.layout

        scene = context.scene
        
        layout.label(text="Add:")
        #Add plane with particle system
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple44")
        #Add bevel modifier
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple55")
        
        
        layout.label(text="Replacement:")
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple11")
        #replace with grid button
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple111")
        #replace with icosphere button
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple22")
        #replace with cube button
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple33")
        #replace with cone button
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple77")
        
        # Delete Mesh button
        layout.label(text="Remove:")
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple_operator")
        #Remove bevel Modifier
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple66")
        
        layout.label(text="Extra Operations:")
        row = layout.row()
        row.scale_y = 1.9
        row.operator("object.simple88")
        
        


# Registers classes

def register():
    bpy.utils.register_class(Delete)
    bpy.utils.register_class(RepWithSphere)
    bpy.utils.register_class(RepWithGrid)
    bpy.utils.register_class(RepWithIcosphere)
    bpy.utils.register_class(RepWithCube)
    bpy.utils.register_class(AddPlnWithPtcleSstm)
    bpy.utils.register_class(AddBevelModifier)
    bpy.utils.register_class(RemoveBevelModifier)
    bpy.utils.register_class(RepWithCone)
    bpy.utils.register_class(Decimate)
    bpy.utils.register_class(MeshOperationsPanel)
    

# Unregisters classes

def unregister():
    bpy.utils.unregister_class(Delete)
    bpy.utils.unregister_class(RepWithSphere)
    bpy.utils.unregister_class(RepWithGrid)
    bpy.utils.unregister_class(RepWithIcosphere)
    bpy.utils.unregister_class(RepWithCube)
    bpy.utils.unregister_class(AddPlnWithPtcleSstm)
    bpy.utils.unregister_class(AddBevelModifier)
    bpy.utils.unregister_class(RemoveBevelModifier)
    bpy.utils.unregister_class(RepWithCone)
    bpy.utils.unregister_class(Decimate)
    bpy.utils.unregister_class(MeshOperationsPanel)
   

if __name__ == "__main__":
    register()

# Developed by Ali Soltanian Fard Jahromi (https://alisoltanian.com/)